dofile_once( "mods/mnee/lib.lua" )

function get_sign( a )
	if( a < 0 ) then
		return -1
	else
		return 1
	end
end

local entity_id = GetUpdatedEntityID()

local speed = 5

local trans_comp = EntityGetFirstComponentIncludingDisabled( entity_id, "InheritTransformComponent" )
local origs = { ComponentGetValue2( trans_comp, "Transform" ) }

if( is_binding_down( "kappa", "ab_left", true )) then
	origs[1] = origs[1] - speed
end
if( is_binding_down( "kappa", "ad_right", true )) then
	origs[1] = origs[1] + speed
end
if( is_binding_down( "kappa", "ac_down", true )) then
	origs[2] = origs[2] + speed
end
if( is_binding_down( "kappa", "aa_up", true )) then
	origs[2] = origs[2] - speed
end

origs[1] = origs[1] + get_axis_state( "kappa", "ab_movement_h", true )*speed
origs[2] = origs[2] + get_axis_state( "kappa", "aa_movement_v", true )*speed

local limit_x, limit_y = MagicNumbersGetValue( "VIRTUAL_RESOLUTION_X" )/2, MagicNumbersGetValue( "VIRTUAL_RESOLUTION_Y" )/2
ComponentSetValue2( trans_comp, "Transform", math.min( math.abs( origs[1] ), limit_x )*get_sign( origs[1] ), math.min( math.abs( origs[2] ), limit_y )*get_sign( origs[2] ), 1, 1, 0 )

local is_done = is_binding_down( "kappa", "ai_shoot", true ) or is_binding_down( "kappa", "aj_melee", true ) or get_binding_pressed( "kappa", "al_suicide" )
if( is_done ) then
	GameRemoveFlagRun( "KAPPA_IS_ACTIVE" )
end