bindings["kappa"] = {
	aa_movement_v = {
		name = "Movement Vertical",
		desc = "Controls up and down.",
		keys = { "is_axis", "1gpd_axis_lv", },
	},
	ab_movement_h = {
		name = "Movement Horizontal",
		desc = "Controls left and right.",
		keys = { "is_axis", "1gpd_axis_lh", },
	},
	ac_aim_v = {
		name = "Aim Vertical",
		desc = "Controls up and down.",
		keys = { "is_axis", "1gpd_axis_rv", },
	},
	ad_aim_h = {
		name = "Aim Horizontal",
		desc = "Controls left and right.",
		keys = { "is_axis", "1gpd_axis_rh", },
	},
	
	aa_up = {
		name = "Move Up",
		desc = "Does what it says.",
		keys = {
			keypad_8 = 1,
		},
	},
	ab_left = {
		name = "Move Left",
		desc = "Does what it says.",
		keys = {
			keypad_4 = 1,
		},
	},
	ac_down = {
		name = "Move Down",
		desc = "Does what it says.",
		keys = {
			keypad_5 = 1,
		},
	},
	ad_right = {
		name = "Move Right",
		desc = "Does what it says.",
		keys = {
			keypad_6 = 1,
		},
	},
	ae_aim_up = {
		name = "Aim Down",
		desc = "Does what it says.",
		keys = {
			down = 1,
		},
	},
	af_aim_down = {
		name = "Aim Up",
		desc = "Does what it says.",
		keys = {
			up = 1,
		},
	},
	
	ag_next_gun = {
		name = "Next Attack",
		desc = "Switches between ranged attack modes, assuming there're many or any.",
		keys = {
			right = 1,
		},
	},
	ah_previous_gun = {
		name = "Previous Attack",
		desc = "Switches between ranged attack modes, assuming there're many or any.",
		keys = {
			left = 1,
		},
	},
	
	ai_shoot = {
		name = "Shoot",
		desc = "Creature will attempt to perform a randged attack.",
		keys = {
			keypad_0 = 1,
		},
	},
	aj_melee = {
		name = "Melee",
		desc = "Creature will attempt to perform a melee attack.",
		keys = {
			keypad_1 = 1,
		},
	},
	
	ak_drop = {
		name = "Drop/Pick Up",
		desc = "Creature will drop currently held wand/pick up wand from the floor.",
		keys = {
			keypad_9 = 1,
		},
	},
	al_suicide = {
		name = "Suicide",
		desc = "Creature will die from \"natural\" causes.",
		keys = {
			keypad_7 = 1,
		},
	},
}